import angr
import signal
import sys

TIMEOUT = 60

class TimeoutError(Exception):
    pass

def handler(signum, frame):
    raise TimeoutError

signal.signal(signal.SIGALRM, handler)
path = sys.argv[1]

try:
    signal.alarm(TIMEOUT)
    proj = angr.Project(path, auto_load_libs=False)
    cfg = proj.analyses.CFGFast()

    for node in cfg.nodes():
        block = node.block
        if block is None:
            continue

        print "%s %s\n" % (hex(int(block.addr)),
                           hex(int(block.addr + block.size)))
except TimeoutError:
    print("Timeout")
